#pragma warning (disable : 4305)
#pragma warning (disable : 4244)
#pragma warning (disable : 4786)
#pragma warning (disable : 4312)
#include "DustBunny.h"

void DustBunny::draw()
{
	drawBody();
}

void DustBunny::drawBody()
{
	glPushMatrix();
	blackTexture.use();
	glTranslated(bodyX.getValue(), bodyY.getValue(), bodyZ.getValue());
	glRotated(bodyAlpha.getValue(), 0, 0, 1);
	glRotated(bodyBeta.getValue(), 0, 1, 0);
	glRotated(bodyGamma.getValue(), 1, 0, 0);
	drawSphere(1.0);
	drawFur();
	drawRightEye();
	drawLeftEye();
	drawUpperRightLeg();
	drawUpperLeftLeg();
	drawUpperRightArm();
	drawUpperLeftArm();
	glPopMatrix();
}

void DustBunny::drawUpperRightLeg()
{
	glPushMatrix();
	glTranslated(0, -.8, .5);
	glRotated(90, 1, 0, 0);
	int betaAngle = -1 * rightUpperLegBeta.getValue();
	glRotated(betaAngle, 1, 0, 0);
	int alphaAngle = rightUpperLegAlpha.getValue();
	glRotated(alphaAngle, 0, 1, 0);
	drawCylinder(2, .1, .1);
	drawLowerRightLeg();
	glPopMatrix();
}

void DustBunny::drawUpperLeftLeg()
{
	glPushMatrix();
	glTranslated(0, -.8, -.5);
	glRotated(90, 1, 0, 0);
	int betaAngle = -1 * leftUpperLegBeta.getValue();
	glRotated(betaAngle, 1, 0, 0);
	int alphaAngle = leftUpperLegAlpha.getValue();
	glRotated(alphaAngle, 0, 1, 0);
	drawCylinder(2, .1, .1);
	drawLowerLeftLeg();
	glPopMatrix();
}

void DustBunny::drawLowerLeftLeg()
{
	glPushMatrix();
	glTranslated(0, 0, 2);
	int angle = leftLowerLeg.getValue();
	glRotated(-angle, 0, 1, 0);
	drawSphere(0.1);
	drawCylinder(1.5, .10, .10);
	glTranslated(0, 0, 1.5);
	drawSphere(0.1);
	glPopMatrix();
}

void DustBunny::drawLowerRightLeg()
{
	glPushMatrix();
	glTranslated(0, 0, 2);
	int angle = rightLowerLeg.getValue();
	glRotated(-angle, 0, 1, 0);
	drawSphere(0.1);
	drawCylinder(1.5, .10, .10);
	glTranslated(0, 0, 1.5);
	drawSphere(0.1);
	glPopMatrix();
}

void DustBunny::drawUpperLeftArm()
{
	glPushMatrix();
	glTranslated(0, 0, -.8);
	glRotated(180, 0, 1, 0);
	int alpha = leftUpperArmAlpha.getValue();
	int beta = leftUpperArmBeta.getValue();
	int shoulder = leftShoulder.getValue();
	glRotated(-beta, 0, 1, 0);
	glRotated(-alpha, 1, 0, 0);
	glRotated(shoulder, 0, 0, 1);
	drawCylinder(1.5, .1, .1);
	drawLowerLeftArm();
	glPopMatrix();
}

void DustBunny::drawLowerLeftArm()
{
	glPushMatrix();
	glTranslated(0, 0, 1.5);
	int angle = leftLowerArm.getValue();
	glRotated(angle, 1, 0, 0);
	drawSphere(0.1);
	drawCylinder(1, .1, .1);
	glPushMatrix();
	glTranslated(0, .1, 1);
	drawSphere(0.1);
	glPopMatrix();
	glPushMatrix();
	glTranslated(0, 0, 1);
	drawSphere(0.1);
	glPopMatrix();
	glPushMatrix();
	glTranslated(0, -.1, 1);
	drawSphere(0.1);
	glPopMatrix();
	glPopMatrix();
}

void DustBunny::drawUpperRightArm()
{
	glPushMatrix();
	glTranslated(0, 0, .8);
	int alpha = rightUpperArmAlpha.getValue();
	int beta = rightUpperArmBeta.getValue();
	int shoulder = rightShoulder.getValue();
	glRotated(-beta, 0, 1, 0);
	glRotated(alpha, 1, 0, 0);
	glRotated(shoulder, 0, 0, 1);
	drawCylinder(1.5, .1, .1);
	drawLowerRightArm();
	glPopMatrix();
}

void DustBunny::drawLowerRightArm()
{
	glPushMatrix();
	glTranslated(0, 0, 1.5);
	int angle = rightLowerArm.getValue();
	glRotated(angle, 1, 0, 0);
	drawSphere(0.1);
	drawCylinder(1, .1, .1);
	glPushMatrix();
	glTranslated(0, .1, 1);
	drawSphere(0.1);
	glPopMatrix();
	glPushMatrix();
	glTranslated(0, 0, 1);
	drawSphere(0.1);
	glPopMatrix();
	glPushMatrix();
	glTranslated(0, -.1, 1);
	drawSphere(0.1);
	glPopMatrix();
	glPopMatrix();
}

void DustBunny::drawRightEye()
{
	glPushMatrix();
	glTranslated(0.8, 0, .35);
	int alpha = eyeAlpha.getValue();
	int beta = eyeBeta.getValue();
	glRotated(alpha, 0, 0, 1);
	glRotated(beta, 0, 1, 0);
	whiteTexture.use();
	drawSphere(0.3);
	blackTexture.use();
	drawPupil();
	glPopMatrix();
}

void DustBunny::drawLeftEye()
{
	glPushMatrix();
	glTranslated(0.8, 0, -.35);
	int alpha = eyeAlpha.getValue();
	int beta = eyeBeta.getValue();
	glRotated(alpha, 0, 0, 1);
	glRotated(beta, 0, 1, 0);
	whiteTexture.use();
	drawSphere(0.3);
	blackTexture.use();
	drawPupil();
	glPopMatrix();
}

void DustBunny::drawPupil()
{
	glPushMatrix();
	glTranslated(0.25, 0, 0);
	drawSphere(0.1);
	glPopMatrix();

}

void DustBunny::drawFur()
{
	glPushMatrix();
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	for (int i = 0; i < 120; i++) {
		glRotated(3, 1, 0, 0);
		for (int j = 0; j < 120; j++) {
			glRotated(3, 0, 1, 0);
			if (j > 43) {
				glBegin(GL_LINES);
				glTexCoord2f(0, 0);
				glColor4b(0, 0, 0, 255);
				glVertex3f(0, 0, 0);
				glTexCoord2f(0, 1);
				glColor4b(0, 0, 0, 20);
				glVertex3f(0, 0, 1.2);
				glEnd();
			}
		}
	}
	glPopMatrix();
}





